#include			<stdio.h>
#include			<stdlib.h>
#include			<alloc.h>
#include			<float.h>
#include			<math.h>
#include			<float.h>
#include			<string.h>
#include			<time.h>
#include			"my_menu.h"
#include			"adeshdef.h"
#include			"adeshve.h"
#include			"desh_gen.h"
#include			"deshgrph.h"
#include			"deshfile.h"

int menu_read_file(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
	{
		Read_CC();
		return(VN_MENU_CONTINUE);
	}

int menu_save_cell(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
	{
		int j;
		VN_New_Screen();
		Save_CC(CURRENT_FILE);
		return(VN_MENU_CONTINUE);
	}


int menu_save_as_cell(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
 {
		int j;
		VN_New_Screen();
		Save_CC(USER_DEFINED_FILE);
		return(VN_MENU_CONTINUE);
 }


int menu_list_file(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
 {
		int j;
		List_CC();
		return(VN_MENU_CONTINUE);
 }

int menu_print(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
	{
		int j;
		Print_CC();
		return(VN_MENU_CONTINUE);
	}

int menu_select_and_view(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
 {
	int	i;
	VN_Menu	View_Orient;
		if(Init_VN_Menu(&View_Orient, "Main/File/View Menu", 5, 5) == VN_MENU_ERROR)
				{
					printf("\n Can not create Main/File/View menu");
					return(VN_MENU_EXIT);
				}

		Init_VN_Menu_Entry(&View_Orient, 1," Y vs X", menu_view_type);
		Init_VN_Menu_Entry(&View_Orient, 2," Z vs X", menu_view_type);
		Init_VN_Menu_Entry(&View_Orient, 3," Y vs Z", menu_view_type);
		Init_VN_Menu_Entry(&View_Orient, 4," Color code planes", menu_plane_or_atom);
		Init_VN_Menu_Entry(&View_Orient, 5," Color code atoms", menu_plane_or_atom);

		Handle_VN_Menu(&View_Orient, 1);
/*
		while(Handle_VN_Menu(&View_Orient, 1) == VN_MENU_CONTINUE)
			{
			}
		Close_VN_Menu(&View_Orient);
*/
	return(VN_MENU_CONTINUE);
 }


int menu_exit(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
 {
		 int i;
		 FILE *fp;

			if(DEMO == DESH_YES)
				{
		VN_New_Screen();
		printf("  A file created/read & modified is saved automatically.");
		printf("\n  This feature is available in registered version.");
		printf("\n  Hit any key to continue ...");
		get_key_press();
		free(atom_ptr);
		exit(0);
				}

		if(File_Modification == DESH_NO)
			{
				VN_New_Screen();
				printf("\n  That's all Folks ....");
				get_key_press();
				exit(0);
			}


		printf("Data not saved. Save it (Y/N) ? ");
		i=0;
		while((i != 'N') && (i != 'n') && (i != 'Y') && (i != 'y') && (i != 27))
		{
		 i=get_key_press();
		}
		if(i == 27)			/* Escape key pressed */
			return(VN_MENU_EXIT);

		if((i == 'y') || (i == 'Y'))
			{
				if(open_file_name[0] == '\0')
					{
						if(Save_CC(USER_DEFINED_FILE) == DESH_NO)
							{
								return(VN_MENU_EXIT);
							}
					}
				else
					{
						if(Save_CC(CURRENT_FILE) == DESH_NO)
							{
								return(VN_MENU_EXIT);
							}
					}
			}
		printf("\n That's all folks ....\n\n Hit any key to exit");
		i=get_key_press();
		free(atom_ptr);
		exit(0);
 }


int menu_view_type(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
 {
	Selected_Plot_Type = VN_Menu_Entry - 1;
	View_CC();
	return(VN_MENU_CONTINUE);
 }

int menu_plane_or_atom(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
 {
	Plot_Color_Code = (int)VN_Menu_Entry - 4;
	return(VN_MENU_CONTINUE);
 }


int sort_function( const void *c, const void *d)
{
	struct atom_specs *a, *b;
	a = (struct atom_specs *)c;
	b = (struct atom_specs *)d;
 if((a->XC == b->XC) && (a->YC == b->YC) && (a->ZC == b->ZC))
	return(0);

	if(a->ZC < b->ZC)
		return(-1);
	if(a->ZC > b->ZC)
		return(1);

	if(a->YC < b->YC)
		return(-1);
	if(a->YC > b->YC)
		return(1);

	if(a->XC < b->XC)
		return(-1);
	if(a->XC > b->XC)
		return(1);

	 return(0);
 }


int Read_CC(void)
 {
	float a,b,c,d;
	int i, j, k;
	char temp[50];
	FILE *fp;

	VN_New_Screen();

	if(DEMO == DESH_YES)
		{
			printf("  This feature is available in registered version.");
			printf("\n  Hit any key to continue ...\n\n\n\n\n");
			i=get_key_press();
			VN_New_Screen();
			return(DESH_NO);
		}
	if(Total_Atoms > 0)
		{
			printf("\n  Append to current computation cell (Y/N) ? ");
			i=0;
			while((i != 'Y') && (i != 'y') && (i != 'N') && (i != 'n')
						&& (i != DESH_ESCAPE))
				{
					i=get_key_press();
				}
			if(i == DESH_ESCAPE)
				{
					VN_New_Screen();
					return(DESH_NO);
				}
			if((i == 'N') || (i == 'n'))
				{
					atom_ptr=atom_ptr_temp;
					Total_Atoms=0;
				}
			else
				{
					atom_ptr=atom_ptr_temp;
/* Move the pointer to the end of array */
					i=0;
					while(i<Total_Atoms)
						{
						 atom_ptr++;
						 i++;
						}
					if(Total_Atoms > 0)
						File_Modification = DESH_YES;
				}
		}

	printf("\n File name : ");
	if(get_string(temp) == DESH_NO)
	{
		VN_New_Screen();
		return(DESH_NO);
	}
	strcpy(open_file_name, temp);
	if((fp=fopen(open_file_name,"rt")) == NULL)
	{
	 printf("\n File %s not found\n", open_file_name);
	 strcpy(open_file_name, "");
	 printf("\n Hit any key to continue ....");
	 i=get_key_press();
	 VN_New_Screen();
	 return(DESH_NO);
	}
	else
	{

/* Read the axes of the cell */

		for(i = 0; i< 3; i++)
		{
		 fscanf(fp, "%d %d %d", &file_axes[0][i], &file_axes[1][i],
					&file_axes[2][i]);
		}

/* If the axes in the file are different, we may be reading a wrong file */

		i = 0;
		k = 0;
		while(i < 3)
		{
		 if((axes[i][0] != file_axes[i][0]) ||
			 (axes[i][1] != file_axes[i][1]) ||
			 (axes[i][2] != file_axes[i][2]))
		{
		 printf("\nThe axes for the file differ from current settings");
		 printf("\nContinue reading (Y/N) ? ");
		 k=0;
		 while((k != 'Y') && (k != 'y') &&
				 (k != 'N') && (k != 'n'))
			{
			 k = get_key_press();
			}
		 break;
		}
		 i++;
		}

/* Do not read the cell */

		if((k == 'N') || (k == 'n'))
		{
		 fclose(fp);
		 return(DESH_NO);
		}

/* Redefine the axes based on the settings in the file */

		i=0;
		while(i<3)
		{
		 a=0.;
		 for(j=0; j<3; a=a+file_axes[j][i]*file_axes[j][i], j++);
		 a=(float)sqrt((double)a);
		 for(j=0; j<3; j++)
			{
			new_axes[j][i] = file_axes[j][i];
			axes[j][i] = file_axes[j][i];
			current_axes[j][i] = file_axes[j][i];
			rotate_axes[j][i] = axes[j][i];
			new_basis_vector[j][i] = (float)axes[j][i]/a;
			current_basis_vector[j][i] = new_basis_vector[j][i];
			rotate_basis_vector[j][i] = current_basis_vector[j][i];
			}
		 i++;
		}
		i=matrix_inverse(new_basis_vector,f_make);
		i=matrix_inverse(rotate_basis_vector, f_rotate);

/* Now read the atoms */

	 while((fscanf(fp,"%f %f %f %f",&a,&b,&c,&d) != EOF) &&
	(Total_Atoms < MAX_ATOMS))
		{
		atom_ptr->XC = a;
		atom_ptr->YC = b;
		atom_ptr->ZC = c;
		atom_ptr->TYPE = (int)d;
		atom_ptr++;
		Total_Atoms++;
		}

	 if(Total_Atoms == MAX_ATOMS)
		{
		printf(" Reached the limit of %d atoms\n",Total_Atoms);
		printf("\n Hit any key to continue ....");
		i=get_key_press();
		VN_New_Screen();
		fclose(fp);
		return(DESH_NO);
		}

	 fclose(fp);
	 atom_ptr=atom_ptr_temp;
	 printf("\n %d Atoms read from the file ",Total_Atoms);
	 printf("\n Sorting the atoms .....");
	 planes_and_periodicity();
	 VN_New_Screen();
	 return(DESH_YES);
	}
 }

int List_CC(void)
	{
		int i,j,k;
		atom_ptr=atom_ptr_temp;

		if(DEMO == DESH_YES)
			{
				VN_New_Screen();
				printf("  This feature is available in registered version.");
				printf("\n  Hit any key to continue ...");
				i=get_key_press();
				VN_New_Screen();
				return(DESH_NO);
			}


		if(Total_Atoms == 0)
			{
				VN_New_Screen();
				printf("\nNo cell constructed or read in\n");
				printf("\n Hit any key to continue ....");
				i=get_key_press();
				VN_New_Screen();
				return(DESH_NO);
			}
		else
			{
				 j=0;
				 for(i=0; i<Total_Atoms; i++)
					{
						if(j == 0)
							{
					printf("\tAtom       X         Y         Z       Type");
					printf("\n\t-------------------------------------------\n");
							}
					printf("\t%4.1d %9.2f %9.2f %9.2f      %s\n",
							i+1, atom_ptr->XC, atom_ptr->YC, atom_ptr->ZC,
							Chem_Sym[(int)atom_ptr->TYPE]);
					atom_ptr++;
					j++;
					if(j == 22)
						{
							k=get_key_press();
							if((k == 'E') || (k == 'e'))
									return(DESH_YES);
							j=0;
						}
					}
				 return(DESH_YES);
			}
		return(DESH_YES);
	}

int Print_CC(void)
	{
		int i,j;
		FILE	*f_temp;
		atom_ptr=atom_ptr_temp;

		if(DEMO == DESH_YES)
			{
				VN_New_Screen();
				printf("  This feature is available in registered version.");
				printf("\n  Hit any key to continue ...");
				i=get_key_press();
				VN_New_Screen();
				return(DESH_NO);
			}


		if(Total_Atoms == 0)
			{
				VN_New_Screen();
				printf("\nNo cell constructed or read in\n");
				printf("\n Hit any key to continue ....");
				i=get_key_press();
				VN_New_Screen();
				return(DESH_NO);
			}
		else
			{
			 if((f_temp = fopen("adesh.cc","wt")) != NULL)
				{
				 j=0;
				 for(i=0; i<Total_Atoms; i++)
					{
						if(j == 0)
							{
								fprintf(f_temp, "\n\tFile : %s\n\n", open_file_name);
					fprintf(f_temp, "\tAtom       X         Y         Z       Type");
					fprintf(f_temp, "\n\t-------------------------------------------\n");
							}
					fprintf(f_temp,"\t%4.1d %9.2f %9.2f %9.2f      %s\n",
							i+1, atom_ptr->XC, atom_ptr->YC, atom_ptr->ZC,
							Chem_Sym[(int)atom_ptr->TYPE]);
					atom_ptr++;
					j++;
					if(j == 50)
						{
							fprintf(f_temp, "\f");
							j=0;
						}
					}
				 fprintf(f_temp, "\f");
				 fclose(f_temp);
/*				 clrscr();
				 system("copy adesh.cc prn:");
				 clrscr();
*/
				 return(DESH_YES);
				}
			}
		return(DESH_YES);
	}

int Save_CC(int current_or_user_defined)
 {
	int	i;
	FILE *fp;
	char	temp[50];

	atom_ptr=atom_ptr_temp;
	VN_New_Screen();

	if(DEMO == DESH_YES)
	{
		printf("  This feature is available in registered version");
		printf("\n  Hit any key to continue ....");
		i=get_key_press();
		return(DESH_NO);
	}
	if(Total_Atoms == 0)
	{
	 printf("\n No cell constructed or read in\n");
	 printf("\n Hit any key to continue ....");
	 i=get_key_press();
	 return(DESH_NO);
	}

	if(current_or_user_defined == CURRENT_FILE)
		{
			if(open_file_name[0] == '\0')
				{
					printf("File name : ");
					if(get_string(temp) == DESH_NO)
						{
							return(DESH_NO);
						}
					if((fp = fopen(open_file_name,"rt")) != NULL)
						{
							fclose(fp);
							printf("\n\n\t File exists on the system\n");
							printf("\t\tReplace it (Y/N) ? ");
							i=0;
							while((i != 'Y') && (i != 'y') && (i != 'N') && (i != 'n') &&
										(i != DESH_ESCAPE))
								{
									i=get_key_press();
								}
							if((i == DESH_ESCAPE) || (i == 'n') || (i == 'N'))
								{
									return(DESH_NO);
								}
						}
				 strcpy(open_file_name, temp);
				}
			else
				{
					printf("\n Replace file %s  (Y/N) ? ", open_file_name);
					i=0;
					while((i != 'Y') && (i != 'y') && (i != 'n') && (i != 'N') &&
								(i != DESH_ESCAPE))
						{
							i=get_key_press();
						}
					if((i == DESH_ESCAPE) || (i == 'N') || (i == 'n'))
						{
							return(DESH_NO);
						}
				}
			fp=fopen(open_file_name,"wt");
		}
	else
		{
			printf("File name : ");
			if(get_string(temp) == DESH_NO)
				{
					return(DESH_NO);
				}
			if((fp = fopen(temp,"rt")) != NULL)
				{
					fclose(fp);
					printf("\n\n\t\a%s file exists on the system\n", temp);
					printf("\t\tReplace it (Y/N) ? ");
					i=0;
					while((i != 'Y') && (i != 'y') && (i != 'N') && (i != 'n') &&
								(i != DESH_ESCAPE))
						{
							i=get_key_press();
						}
					if((i == 27) || (i == 'n') || (i == 'N'))
						{
							return(DESH_NO);
						}
				}
			fp=fopen(temp,"wt");
		}

/* Save the axes first */
		for(i = 0; i< 3; i++)
		 {
	fprintf(fp, "%d %d %d\n", current_axes[0][i], current_axes[1][i],
					current_axes[2][i]);
		 }


		i=0;
		while(i<Total_Atoms)
		 {
			fprintf(fp, "%f %f %f %f\n",
				atom_ptr->XC,
				atom_ptr->YC,
				atom_ptr->ZC,
				(float)atom_ptr->TYPE);
			atom_ptr++;
			i++;
		 }
		fclose(fp);
		File_Modification = DESH_NO;
		return(DESH_YES);
 }





int planes_and_periodicity(void)
 {
	int i,j,k;
	float a;

	 if(Total_Atoms <= 0)
		{
		printf("No cell created or read in\n");
		printf("Hit any key to continue ...");
		i=get_key_press();
		return(DESH_NO);
		}

	 printf("\n\n\n      Direction                   Periodicity");
	 printf("\n--------------------------------------------------------");

	j=0;
	while(j<3)
	{
	 atom_ptr=atom_ptr_temp;
	 i=0;
	 while(i<Total_Atoms)
		{
		a = atom_ptr->XC;
		atom_ptr->XC = atom_ptr->YC;
		atom_ptr->YC = atom_ptr->ZC;
		atom_ptr->ZC = a;
		i++;
		atom_ptr++;
		}

	 atom_ptr = atom_ptr_temp;
	 qsort((void *)atom_ptr, Total_Atoms, 14, sort_function);
	 assign_planes();

	 Total_Planes[j] = cell_planes;
	 find_periodicity(&i, &a);
	 Periodic_Planes[j] = i;
	 Periodic_Block[j] = a;
	 printf("\nLooking along %c Axis  # planes %2d  Block size %7.2f",
		XYZ[j], Periodic_Planes[j], Periodic_Block[j]);
	 j++;
	}
		printf("\n\n\n\n Hit any key to continue ....");
		i=get_key_press();
		return(DESH_YES);
 }

 void assign_planes()
	{
	 int i,j,k;
	 int histogram[15];
	 float z_max,z_min,z_range;
	 int MAX_PLANES;
	 float current_z, current_y, current_x;
	 int cell_periodicity;

	cell_planes=0;
	if(Total_Atoms == 0)
	 {
		printf("\nNo cell constructed or read in\n");
	}

		atom_ptr = atom_ptr_temp;
	current_z = atom_ptr->ZC - 2.*plane_thickness;
	i=0;
	while(i<Total_Atoms)
	 {
		if(atom_ptr->ZC - current_z > plane_thickness)
		 {
			cell_planes++;
			atom_ptr->PLANE = cell_planes;
			current_z=atom_ptr->ZC;
		 }
		else
		 {
			atom_ptr->PLANE = cell_planes;
		}
		atom_ptr++;
		i++;
	 }
	}


int compare_planes(int i_plane, int j_plane)
 {
	int i,j;
	struct atom_specs  *plane_i_ptr, *plane_j_ptr;
	float a,b,c;
	int number_of_matches, match_found;

	plane_i_ptr = atom_ptr_temp;
	number_of_matches = 0;

	i=0;
	while(i<Total_Atoms)
	 {
		if(plane_i_ptr->PLANE == i_plane)
		 {
			if((plane_i_ptr->XC > subset[CELL_SIZE].XMIN+4.) &&
	 (plane_i_ptr->XC < subset[CELL_SIZE].XMAX-4.) &&
	 (plane_i_ptr->YC > subset[CELL_SIZE].YMIN+4.) &&
	 (plane_i_ptr->YC < subset[CELL_SIZE].YMAX-4.))
			 {
	plane_j_ptr = plane_i_ptr;
	plane_j_ptr++;
	j = i+1;
	match_found = DESH_NO;
	while((j < Total_Atoms) && (plane_j_ptr->PLANE <= j_plane))
	 {
		if(plane_j_ptr->PLANE == j_plane)
		 {
			a=plane_i_ptr->XC - plane_j_ptr->XC;
			b=plane_i_ptr->YC - plane_j_ptr->YC;
			if((a <= position_error) && (a >= -position_error) &&
				 (b <= position_error) && (b >= -position_error))

				 {
		match_found = DESH_YES;
		number_of_matches++;
		break;
				 }
		 }
		plane_j_ptr++;
		j++;
	 }

	if(match_found == DESH_NO)
	 return(-1);
			 }
		 }

		i++;
		plane_i_ptr++;
	 }
	if(number_of_matches == 0)
	 return(-1);
	else
	 return(0);
 }

void find_periodicity(int *P_Planes, float *P_Block)
 {
	int i,j,k,l;
	int first_plane, second_plane;
	int match_found;

	float a, b;

	first_plane = 1;
	second_plane = 3;
	while(second_plane<=cell_planes)
	 {
		if(compare_planes(first_plane,second_plane) == 0)
		 {
			j=first_plane+1;
			k=second_plane+1;
			match_found = DESH_YES;
			while((j<second_plane) && (k <= cell_planes))
			 {
	if(compare_planes(j, k) != 0)
	 {
		match_found = DESH_NO;
		break;
	 }
	j++;
	k++;
			 }
			if(match_found == DESH_YES)
			 {
	break;
			 }
		 }
		second_plane++;
	 }

	if(match_found == DESH_NO)
	 {
		first_plane = 1;
		second_plane = 3;
		printf("\nA periodic block was not found\n");
	 }

	*P_Planes = second_plane - first_plane;

	atom_ptr = atom_ptr_temp;
	a=0.;
	i=0;
	while(i<Total_Atoms)
	 {
		if(atom_ptr->PLANE == first_plane)
		 {
			a = atom_ptr->ZC;
			break;
		 }
		atom_ptr++;
		i++;
	 }


	atom_ptr = atom_ptr_temp;
	b=0.;
	i=0;
	while(i<Total_Atoms)
	{
		if(atom_ptr->PLANE == second_plane)
		 {
			b = atom_ptr->ZC;
			break;
		 }
		atom_ptr++;
		i++;
	 }

	b = b-a;
	if(b < 0)
	 b = 0;

	*P_Block = b;
 }
